"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ObjectRenderer = void 0;
var _react = _interopRequireDefault(require("react"));
var _memo = require("@ui-schema/ui-schema/Utils/memo");
var _PluginStack = require("@ui-schema/ui-schema/PluginStack");
var _excluded = ["level", "schema", "storeKeys", "schemaKeys", "errors"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var ObjectRendererBase = function ObjectRendererBase(_ref) {
  var level = _ref.level,
    schema = _ref.schema,
    storeKeys = _ref.storeKeys,
    schemaKeys = _ref.schemaKeys,
    errors = _ref.errors,
    props = _objectWithoutProperties(_ref, _excluded);
  var isVirtual = props.isVirtual,
    widgets = props.widgets;
  var properties = schema.get('properties');
  if (!isVirtual && !widgets.GroupRenderer) {
    if (process.env.NODE_ENV === 'development') {
      console.error('Widget GroupRenderer not existing');
    }
    return null;
  }
  var GroupRenderer = widgets.GroupRenderer;
  var propertyTree = (properties === null || properties === void 0 ? void 0 : properties.map(function (childSchema, childKey) {
    return _react["default"].createElement(_PluginStack.PluginStack, _extends({
      key: childKey
    }, props, {
      schema: childSchema,
      parentSchema: schema,
      storeKeys: storeKeys.push(childKey),
      schemaKeys: schemaKeys === null || schemaKeys === void 0 ? void 0 : schemaKeys.push('properties').push(childKey),
      level: level + 1
    }));
  }).valueSeq()) || null;
  return isVirtual ? propertyTree : properties ? _react["default"].createElement(GroupRenderer, {
    storeKeys: storeKeys,
    schemaKeys: schemaKeys,
    level: level,
    noGrid: props.noGrid,
    schema: schema
  }, propertyTree) : null;
};
var ObjectRenderer = exports.ObjectRenderer = (0, _memo.memo)(ObjectRendererBase);