"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReferencingHandler = void 0;
var _react = _interopRequireDefault(require("react"));
var _Translate = require("@ui-schema/ui-schema/Translate");
var _SchemaRootProvider = require("@ui-schema/ui-schema/SchemaRootProvider");
var _ReferencingHandler = require("@ui-schema/ui-schema/Plugins/ReferencingHandler");
var _PluginStack = require("@ui-schema/ui-schema/PluginStack");
var _getSchema = require("@ui-schema/ui-schema/Utils/getSchema");
var _excluded = ["rootContext"],
  _excluded2 = ["schema", "definitions"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var ReferencingHandler = exports.ReferencingHandler = function ReferencingHandler(_ref) {
  var rootContext = _ref.rootContext,
    props = _objectWithoutProperties(_ref, _excluded);
  var baseSchema = props.schema,
    isVirtual = props.isVirtual;
  var _useSchemaRoot = (0, _SchemaRootProvider.useSchemaRoot)(),
    maybeRootSchema = _useSchemaRoot.schema,
    maybeDefinitions = _useSchemaRoot.definitions,
    nestedRootProps = _objectWithoutProperties(_useSchemaRoot, _excluded2);
  var isRoot = Boolean((0, _SchemaRootProvider.isRootSchema)(baseSchema) || rootContext || baseSchema.get('definitions') || baseSchema.get('$defs'));
  var definitions = isRoot ? baseSchema.get('definitions') || baseSchema.get('$defs') : maybeDefinitions;
  var _useSchemaRef = (0, _ReferencingHandler.useSchemaRef)(maybeRootSchema, definitions, isRoot, baseSchema),
    schema = _useSchemaRef.schema,
    refsPending = _useSchemaRef.refsPending;
  return refsPending && refsPending.size > 0 ? isVirtual ? null : _react["default"].createElement(_Translate.Trans, {
    text: 'labels.loading',
    fallback: 'Loading'
  }) : isRoot ? _react["default"].createElement(_SchemaRootProvider.SchemaRootProvider, _extends({}, nestedRootProps, rootContext || {}, {
    id: (0, _getSchema.getSchemaId)(schema),
    schema: schema,
    definitions: definitions
  }), _react["default"].createElement(_PluginStack.NextPluginRendererMemo, _extends({}, props, {
    schema: schema
  }))) : _react["default"].createElement(_PluginStack.NextPluginRendererMemo, _extends({}, props, {
    schema: schema
  }));
};