"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReferencingNetworkHandler = void 0;
var _react = _interopRequireDefault(require("react"));
var _PluginStack = require("@ui-schema/ui-schema/PluginStack");
var _Trans = require("@ui-schema/ui-schema/Translate/Trans");
var _ReferencingHandler = require("@ui-schema/ui-schema/Plugins/ReferencingHandler");
var _excluded = ["Plugin", "currentPluginIndex"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var RefLoader = function RefLoader(_ref) {
  var _schema;
  var Plugin = _ref.Plugin,
    currentPluginIndex = _ref.currentPluginIndex,
    props = _objectWithoutProperties(_ref, _excluded);
  var schema = props.schema,
    schemaRef = props.schemaRef,
    isVirtual = props.isVirtual;
  var _useSchemaNetworkRef = (0, _ReferencingHandler.useSchemaNetworkRef)(),
    loadSchema = _useSchemaNetworkRef.loadSchema,
    getSchema = _useSchemaNetworkRef.getSchema;
  var schemaVersion = (_schema = schema) === null || _schema === void 0 ? void 0 : _schema.get('version');
  var loadedSchema = getSchema(schemaRef, undefined, schemaVersion);
  var loaded = Boolean(loadedSchema);
  if (loaded) {
    schema = loadedSchema;
  }
  _react["default"].useEffect(function () {
    if (!loaded) {
      loadSchema(schemaRef, undefined, [schemaVersion]);
    }
  }, [loadSchema, schemaRef, schemaVersion, loaded]);
  return !loaded ? isVirtual ? null : _react["default"].createElement(_Trans.Trans, {
    text: 'labels.loading',
    fallback: 'Loading'
  }) : _react["default"].createElement(Plugin, _extends({}, props, {
    currentPluginIndex: currentPluginIndex,
    schema: schema
  }));
};
var ReferencingNetworkHandler = exports.ReferencingNetworkHandler = function ReferencingNetworkHandler(props) {
  var schema = props.schema,
    currentPluginIndex = props.currentPluginIndex;
  var next = currentPluginIndex + 1;
  var Plugin = (0, _PluginStack.getNextPlugin)(next, props.widgets);
  var ref = schema.get('$ref');
  return ref && ref.indexOf('#') !== 0 ? _react["default"].createElement(RefLoader, _extends({}, props, {
    Plugin: Plugin,
    currentPluginIndex: next,
    schemaRef: ref
  })) : _react["default"].createElement(Plugin, _extends({}, props, {
    currentPluginIndex: next
  }));
};