"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeUrlFromRef = exports.isRelUrl = exports.getFragmentFromUrl = exports.getCleanRefUrl = void 0;
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var isRelUrl = exports.isRelUrl = function isRelUrl(schemaRef) {
  return schemaRef.indexOf('https://') !== 0 && schemaRef.indexOf('http://') !== 0 && schemaRef.indexOf('ftp://') !== 0 && schemaRef.indexOf('ftps://') !== 0 && schemaRef.indexOf('#') !== 0;
};
var removeFragmentFromRevUrl = function removeFragmentFromRevUrl(url) {
  return url.slice(url.indexOf('#/') !== -1 ? url.indexOf('#/') + 2 : url.indexOf('#') !== -1 ? url.indexOf('#') + 1 : 0);
};
var getFragmentFromUrl = exports.getFragmentFromUrl = function getFragmentFromUrl(url) {
  var revUrl = _toConsumableArray(url).reverse().join('');
  var revUrlFragment = revUrl.slice(0, revUrl.indexOf('#/') !== -1 ? revUrl.indexOf('#/') : revUrl.indexOf('#') !== -1 ? revUrl.indexOf('#') : 0);
  return _toConsumableArray(revUrlFragment).reverse().join('');
};
var getCleanRefUrl = exports.getCleanRefUrl = function getCleanRefUrl(schemaRef) {
  if (typeof schemaRef === 'string') {
    var revId = _toConsumableArray(schemaRef).reverse().join('');
    var revIdNoFragment = removeFragmentFromRevUrl(revId);
    schemaRef = _toConsumableArray(revIdNoFragment).reverse().join('');
  }
  return schemaRef;
};
var makeUrlFromRef = exports.makeUrlFromRef = function makeUrlFromRef(schemaRef, id) {
  var schemaUrl = schemaRef;
  if (id) {
    var revId = _toConsumableArray(id).reverse().join('');
    var revIdNoFragment = removeFragmentFromRevUrl(revId);
    var uriBase = _toConsumableArray(revIdNoFragment.slice(revIdNoFragment.indexOf('/'))).reverse().join('');
    schemaUrl = uriBase + schemaRef;
  } else if (process.env.NODE_ENV === 'development') {
    console.warn('relative uri ref without root id', schemaRef);
  }
  return schemaUrl;
};