"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UIConfigProvider = void 0;
exports.UIStoreProvider = UIStoreProvider;
exports.useUI = void 0;
exports.useUIConfig = useUIConfig;
exports.useUIStore = void 0;
var _react = _interopRequireDefault(require("react"));
var _UIStoreActions = require("@ui-schema/ui-schema/UIStoreActions");
var _excluded = ["children"],
  _excluded2 = ["children", "showValidity", "onChange", "store"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var UIStoreContextObj = _react["default"].createContext({});
var UIConfigContextObj = _react["default"].createContext({});
var UIConfigProvider = exports.UIConfigProvider = function UIConfigProvider(_ref) {
  var children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  var value = _react["default"].useMemo(function () {
    return _objectSpread({}, props);
  }, _toConsumableArray(Object.values(props)));
  return _react["default"].createElement(UIConfigContextObj.Provider, {
    value: value
  }, children);
};
function UIStoreProvider(_ref2) {
  var children = _ref2.children,
    showValidity = _ref2.showValidity,
    onChange = _ref2.onChange,
    store = _ref2.store,
    props = _objectWithoutProperties(_ref2, _excluded2);
  var ctx = _react["default"].useMemo(function () {
    return {
      showValidity: showValidity,
      store: store
    };
  }, [showValidity, store]);
  return _react["default"].createElement(UIStoreContextObj.Provider, {
    value: ctx
  }, _react["default"].createElement(UIConfigProvider, props, _react["default"].createElement(_UIStoreActions.UIStoreActionsProvider, {
    onChange: onChange
  }, children)));
}
var useUI = exports.useUI = function useUI() {
  return useUIStore();
};
var useUIStore = exports.useUIStore = function useUIStore() {
  return _react["default"].useContext(UIStoreContextObj);
};
function useUIConfig() {
  return _react["default"].useContext(UIConfigContextObj);
}