"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useDebounceValue = void 0;
var _react = _interopRequireDefault(require("react"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var useDebounceValue = exports.useDebounceValue = function useDebounceValue(value, debounceTime, setter) {
  var timer = _react["default"].useRef(undefined);
  var _React$useState = _react["default"].useState({
      changed: false,
      value: undefined
    }),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    bounceVal = _React$useState2[0],
    setBounceVal = _React$useState2[1];
  _react["default"].useLayoutEffect(function () {
    setBounceVal({
      changed: false,
      value: value
    });
    return function () {
      return window.clearTimeout(timer.current);
    };
  }, [value, timer]);
  _react["default"].useEffect(function () {
    if (typeof bounceVal.value === 'undefined' || !bounceVal.changed) return;
    timer.current = window.setTimeout(function () {
      setter(bounceVal.value);
    }, debounceTime);
    return function () {
      return window.clearTimeout(timer.current);
    };
  }, [bounceVal, setBounceVal, debounceTime, timer, setter]);
  var bubbleBounce = _react["default"].useCallback(function (currentVal) {
    if (bounceVal.value === currentVal) return;
    window.clearTimeout(timer.current);
    setter(bounceVal.value);
  }, [setter, bounceVal]);
  var changeBounceVal = _react["default"].useCallback(function (nextVal) {
    setBounceVal({
      changed: true,
      value: nextVal
    });
  }, [setBounceVal]);
  return {
    bubbleBounce: bubbleBounce,
    bounceVal: bounceVal,
    setBounceVal: setBounceVal,
    changeBounceVal: changeBounceVal
  };
};