"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validateOneOf = exports.oneOfValidator = exports.ERROR_ONE_OF_INVALID = void 0;
var _immutable = require("immutable");
var _validateSchema = require("@ui-schema/ui-schema/validateSchema");
var _ValidatorErrors = require("@ui-schema/ui-schema/ValidatorErrors");
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var ERROR_ONE_OF_INVALID = exports.ERROR_ONE_OF_INVALID = 'one-of-is-invalid';
var validateOneOf = exports.validateOneOf = function validateOneOf(oneOfSchemas, value) {
  var recursively = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var errors = (0, _ValidatorErrors.createValidatorErrors)();
  var errorCount = 0;
  if (_immutable.List.isList(oneOfSchemas) || Array.isArray(oneOfSchemas)) {
    var schemas = _immutable.List.isList(oneOfSchemas) ? oneOfSchemas.toArray() : oneOfSchemas;
    var _iterator = _createForOfIteratorHelper(schemas),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var schema = _step.value;
        var tmpErr = (0, _validateSchema.validateSchema)(schema, value, recursively);
        if (tmpErr.hasError()) {
          errors = errors.addErrors(tmpErr);
          errorCount++;
        } else {
          errors = (0, _ValidatorErrors.createValidatorErrors)();
          errorCount = 0;
          break;
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }
  return {
    errors: errors,
    errorCount: errorCount
  };
};
var oneOfValidator = exports.oneOfValidator = {
  should: function should(_ref) {
    var schema = _ref.schema;
    return _immutable.List.isList(schema === null || schema === void 0 ? void 0 : schema.get('oneOf'));
  },
  handle: function handle(_ref2) {
    var schema = _ref2.schema,
      value = _ref2.value,
      errors = _ref2.errors,
      valid = _ref2.valid;
    var tmpErrors = validateOneOf(schema === null || schema === void 0 ? void 0 : schema.get('oneOf'), value);
    if (tmpErrors.errorCount > 0) {
      var _errors, _errors2;
      valid = false;
      errors = (_errors = errors) === null || _errors === void 0 ? void 0 : _errors.addChildErrors(tmpErrors.errors);
      errors = (_errors2 = errors) === null || _errors2 === void 0 ? void 0 : _errors2.addError(ERROR_ONE_OF_INVALID, schema);
    }
    return {
      errors: errors,
      valid: valid
    };
  }
};