"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.requiredValidator = exports.checkValueExists = exports.ERROR_NOT_SET = void 0;
var _immutable = require("immutable");
var _uiSchema = require("@ui-schema/ui-schema");
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var ERROR_NOT_SET = exports.ERROR_NOT_SET = 'required-not-set';
var checkValueExists = exports.checkValueExists = function checkValueExists(type, value) {
  var valType = _typeof(value);
  if (valType === 'undefined') {
    return false;
  }
  if ((0, _uiSchema.schemaTypeIs)(type, 'string') && valType === 'string') {
    return value !== '';
  } else if (valType === 'string' && (0, _uiSchema.schemaTypeIsNumeric)(type)) {
    return value !== '';
  }
  return true;
};
var requiredValidator = exports.requiredValidator = {
  should: function should(_ref) {
    var requiredList = _ref.requiredList,
      storeKeys = _ref.storeKeys;
    if (requiredList && _immutable.List.isList(requiredList)) {
      return requiredList.contains(storeKeys.last());
    }
    return false;
  },
  noHandle: function noHandle() {
    return {
      required: false
    };
  },
  handle: function handle(_ref2) {
    var schema = _ref2.schema,
      value = _ref2.value,
      errors = _ref2.errors,
      valid = _ref2.valid;
    var type = schema.get('type');
    if (!checkValueExists(type, value)) {
      valid = false;
      errors = errors.addError(ERROR_NOT_SET);
    }
    return {
      errors: errors,
      valid: valid,
      required: true
    };
  }
};