"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.valueValidatorConst = exports.validateConst = exports.ERROR_CONST_MISMATCH = void 0;
var _isEqual = require("@ui-schema/ui-schema/Utils/isEqual");
var _immutable = require("immutable");
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var ERROR_CONST_MISMATCH = exports.ERROR_CONST_MISMATCH = 'const-mismatch';
var validateConst = exports.validateConst = function validateConst(_const, value) {
  if (typeof _const === 'undefined' || typeof value === 'undefined') return true;
  var tValue = value;
  if (Array.isArray(value)) {
    tValue = (0, _immutable.List)((0, _immutable.fromJS)(value));
  } else if (_typeof(value) === 'object' && value !== null && !_immutable.List.isList(value) && !_immutable.Map.isMap(value) && !_immutable.Record.isRecord(value)) {
    tValue = (0, _immutable.Map)((0, _immutable.fromJS)(value));
  }
  return (0, _isEqual.isEqual)(tValue, _const);
};
var valueValidatorConst = exports.valueValidatorConst = {
  should: function should(_ref) {
    var schema = _ref.schema,
      value = _ref.value;
    var _const = schema.get('const');
    return typeof _const !== 'undefined' && typeof value !== 'undefined';
  },
  handle: function handle(_ref2) {
    var schema = _ref2.schema,
      value = _ref2.value,
      errors = _ref2.errors,
      valid = _ref2.valid;
    if (!validateConst(schema.get('const'), value)) {
      valid = false;
      errors = errors.addError(ERROR_CONST_MISMATCH, (0, _immutable.Map)({
        "const": schema.get('const')
      }));
    }
    return {
      errors: errors,
      valid: valid
    };
  }
};