"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ValidityReporter = void 0;
var _react = _interopRequireDefault(require("react"));
var _PluginStack = require("@ui-schema/ui-schema/PluginStack");
var _useImmutable = require("@ui-schema/ui-schema/Utils/useImmutable");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var ValidityReporter = exports.ValidityReporter = function ValidityReporter(props) {
  var _React$useState = _react["default"].useState(false),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    customError = _React$useState2[0],
    setCustomError = _React$useState2[1];
  var onChange = props.onChange,
    showValidity = props.showValidity,
    storeKeys = props.storeKeys,
    valid = props.valid,
    currentPluginIndex = props.currentPluginIndex;
  var storeKeysRef = (0, _useImmutable.useImmutable)(storeKeys);
  var realValid = !customError && valid;
  _react["default"].useEffect(function () {
    onChange({
      type: 'set',
      storeKeys: storeKeysRef,
      scopes: ['valid'],
      data: {
        valid: realValid
      }
    });
  }, [realValid, onChange, storeKeysRef]);
  _react["default"].useEffect(function () {
    return function () {
      return onChange({
        type: 'set',
        storeKeys: storeKeysRef,
        scopes: ['valid'],
        data: {
          valid: undefined
        }
      });
    };
  }, [onChange, storeKeysRef]);
  var next = currentPluginIndex + 1;
  var Plugin = (0, _PluginStack.getNextPlugin)(next, props.widgets);
  return _react["default"].createElement(Plugin, _extends({}, props, {
    currentPluginIndex: next,
    valid: valid,
    showValidity: showValidity,
    setCustomError: setCustomError
  }));
};