"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WidgetRenderer = void 0;
var _react = _interopRequireDefault(require("react"));
var _Utils = require("@ui-schema/ui-schema/Utils");
var _widgetMatcher = require("@ui-schema/ui-schema/widgetMatcher");
var _immutable = require("immutable");
var _excluded = ["value", "internalValue", "WidgetOverride", "NoWidget", "errors", "onErrors", "requiredList", "currentPluginIndex"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var WidgetRenderer = exports.WidgetRenderer = function WidgetRenderer(_ref) {
  var value = _ref.value,
    internalValue = _ref.internalValue,
    WidgetOverride = _ref.WidgetOverride,
    NoWidget = _ref.NoWidget,
    errors = _ref.errors,
    onErrors = _ref.onErrors,
    requiredList = _ref.requiredList,
    currentPluginIndex = _ref.currentPluginIndex,
    props = _objectWithoutProperties(_ref, _excluded);
  var schema = props.schema,
    widgets = props.widgets,
    isVirtual = props.isVirtual;
  var currentErrors = (0, _Utils.useImmutable)(errors);
  _react["default"].useEffect(function () {
    return onErrors && onErrors(currentErrors);
  }, [onErrors, currentErrors]);
  var schemaType = schema.get('type');
  var widgetName = schema.get('widget');
  var Widget = (0, _widgetMatcher.widgetMatcher)({
    isVirtual: Boolean(isVirtual),
    WidgetOverride: WidgetOverride,
    NoWidget: NoWidget,
    widgetName: widgetName,
    schemaType: schemaType,
    widgets: widgets
  });
  var noExtractValue = !isVirtual && (schemaType === 'array' || schemaType === 'object' || _immutable.List.isList(schemaType) && (schemaType.indexOf('array') !== -1 || schemaType.indexOf('object') !== -1));
  return Widget ? _react["default"].createElement(Widget, _extends({}, props, {
    value: noExtractValue ? undefined : value,
    internalValue: noExtractValue ? undefined : internalValue,
    errors: currentErrors
  })) : null;
};