const _excluded = ["level", "schema", "storeKeys", "schemaKeys", "errors"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { memo } from '@ui-schema/ui-schema/Utils/memo';
import { PluginStack } from '@ui-schema/ui-schema/PluginStack';
const ObjectRendererBase = _ref => {
  let {
      level,
      schema,
      storeKeys,
      schemaKeys,
      errors
    } = _ref,
    props = _objectWithoutProperties(_ref, _excluded);
  const {
    isVirtual,
    widgets
  } = props;
  const properties = schema.get('properties');
  if (!isVirtual && !widgets.GroupRenderer) {
    if (process.env.NODE_ENV === 'development') {
      console.error('Widget GroupRenderer not existing');
    }
    return null;
  }
  const GroupRenderer = widgets.GroupRenderer;
  const propertyTree = properties?.map((childSchema, childKey) => React.createElement(PluginStack, _extends({
    key: childKey
  }, props, {
    schema: childSchema,
    parentSchema: schema,
    storeKeys: storeKeys.push(childKey),
    schemaKeys: schemaKeys?.push('properties').push(childKey),
    level: level + 1
  }))).valueSeq() || null;
  return isVirtual ? propertyTree : properties ? React.createElement(GroupRenderer, {
    storeKeys: storeKeys,
    schemaKeys: schemaKeys,
    level: level,
    noGrid: props.noGrid,
    schema: schema
  }, propertyTree) : null;
};
export const ObjectRenderer = memo(ObjectRendererBase);