const _excluded = ["StackWrapper", "wrapperProps"],
  _excluded2 = ["widgets"],
  _excluded3 = ["currentPluginIndex"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { List } from 'immutable';
import { memo } from '@ui-schema/ui-schema/Utils/memo';
import { useUIMeta } from '@ui-schema/ui-schema/UIMeta';
import { createValidatorErrors } from '@ui-schema/ui-schema/ValidatorErrors';
import { useUIConfig } from '@ui-schema/ui-schema/UIStore';
import { useImmutable } from '@ui-schema/ui-schema/Utils/useImmutable';
import { PluginStackErrorBoundary } from '@ui-schema/ui-schema/PluginStack';
const errorContainer = createValidatorErrors();
export const PluginStack = _ref => {
  let {
      StackWrapper,
      wrapperProps
    } = _ref,
    props = _objectWithoutProperties(_ref, _excluded);
  const _useUIMeta = useUIMeta(),
    {
      widgets
    } = _useUIMeta,
    meta = _objectWithoutProperties(_useUIMeta, _excluded2);
  const config = useUIConfig();
  const {
    level = 0,
    parentSchema,
    storeKeys = List([]),
    schemaKeys = List([]),
    schema,
    widgets: customWidgets
  } = props;
  const currentStoreKeys = useImmutable(storeKeys);
  const currentSchemaKeys = useImmutable(schemaKeys);
  const activeWidgets = customWidgets || widgets;
  const isVirtual = Boolean(props.isVirtual || schema?.get('hidden'));
  let required = List([]);
  if (parentSchema) {
    let tmp_required = parentSchema.get('required');
    if (tmp_required) {
      required = tmp_required;
    }
  }
  const stack = React.createElement(NextPluginRenderer, _extends({}, meta, config, props, {
    currentPluginIndex: -1,
    widgets: activeWidgets,
    level: level,
    storeKeys: currentStoreKeys,
    schemaKeys: currentSchemaKeys,
    ownKey: storeKeys.last(),
    requiredList: required,
    required: false,
    errors: errorContainer,
    isVirtual: isVirtual,
    valid: true
  }));
  const wrappedStack = StackWrapper && !isVirtual ? React.createElement(StackWrapper, _extends({
    schema: schema,
    storeKeys: currentStoreKeys,
    schemaKeys: currentSchemaKeys
  }, wrapperProps || {}), stack) : stack;
  return props.schema ? activeWidgets?.ErrorFallback ? React.createElement(PluginStackErrorBoundary, {
    FallbackComponent: activeWidgets.ErrorFallback,
    type: schema.get('type'),
    widget: schema.get('widget'),
    storeKeys: currentStoreKeys
  }, wrappedStack) : wrappedStack : null;
};
export const getNextPlugin = (next, {
  pluginStack: ps,
  WidgetRenderer
}) => next < ps.length ? ps[next] || (() => 'plugin-error') : WidgetRenderer;
export const NextPluginRenderer = _ref2 => {
  let {
      currentPluginIndex
    } = _ref2,
    props = _objectWithoutProperties(_ref2, _excluded3);
  const next = currentPluginIndex + 1;
  const Plugin = getNextPlugin(next, props.widgets);
  return React.createElement(Plugin, _extends({}, props, {
    currentPluginIndex: next
  }));
};
export const NextPluginRendererMemo = memo(NextPluginRenderer);