import React from 'react';
export class PluginStackErrorBoundary extends React.Component {
  state = {
    error: null
  };
  static getDerivedStateFromError(error) {
    return {
      error: error
    };
  }
  componentDidCatch(error, info) {
    console.error(error, info);
  }
  render() {
    if (this.state.error) {
      const FallbackComponent = this.props.FallbackComponent;
      return React.createElement(FallbackComponent, {
        error: this.state.error,
        type: this.props.type,
        widget: this.props.widget,
        storeKeys: this.props.storeKeys
      });
    }
    return this.props.children;
  }
}