const _excluded = ["dependencies", "dependentSchemas", "dependentRequired"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { getNextPlugin, NextPluginRendererMemo } from '@ui-schema/ui-schema/PluginStack';
import { useUIStore } from '@ui-schema/ui-schema/UIStore';
import { mergeSchema } from '@ui-schema/ui-schema/Utils/mergeSchema';
import { List, Map } from 'immutable';
const DependentRenderer = _ref => {
  let {
      dependencies,
      dependentSchemas,
      dependentRequired
    } = _ref,
    props = _objectWithoutProperties(_ref, _excluded);
  let {
    schema,
    storeKeys
  } = props;
  const {
    store
  } = useUIStore();
  const currentValues = storeKeys.size ? store?.getValues()?.getIn(storeKeys) : store?.getValues();
  const parsedSchema = React.useMemo(() => {
    let parsedSchema = schema;
    if (!currentValues) return parsedSchema;
    currentValues.keySeq().forEach(key => {
      const key_dependencies = dependencies ? dependencies.get(key) : undefined;
      const key_dependentSchemas = dependentSchemas ? dependentSchemas.get(key) : undefined;
      const key_dependentRequired = dependentRequired ? dependentRequired.get(key) : undefined;
      if (typeof currentValues.get(key) !== 'undefined') {
        if (Map.isMap(key_dependencies) || Map.isMap(key_dependentSchemas)) {
          if (Map.isMap(key_dependencies)) {
            parsedSchema = mergeSchema(parsedSchema, key_dependencies);
          } else {
            parsedSchema = mergeSchema(parsedSchema, key_dependentSchemas);
          }
        }
        if (List.isList(key_dependencies) || List.isList(key_dependentRequired)) {
          const currentRequired = parsedSchema.get('required') || List();
          if (List.isList(key_dependencies)) {
            parsedSchema = parsedSchema.set('required', currentRequired.concat(key_dependencies));
          } else {
            parsedSchema = parsedSchema.set('required', currentRequired.concat(key_dependentRequired));
          }
        }
      }
    });
    return parsedSchema;
  }, [currentValues, schema, dependencies, dependentSchemas, dependentRequired]);
  return React.createElement(NextPluginRendererMemo, _extends({}, props, {
    schema: parsedSchema
  }));
};
export const DependentHandler = props => {
  let {
    storeKeys,
    schema,
    currentPluginIndex
  } = props;
  const next = currentPluginIndex + 1;
  const Plugin = getNextPlugin(next, props.widgets);
  const dependencies = schema.get('dependencies');
  const dependentSchemas = schema.get('dependentSchemas');
  const dependentRequired = schema.get('dependentRequired');
  return dependencies || dependentSchemas || dependentRequired ? React.createElement(DependentRenderer, _extends({
    dependencies: dependencies,
    dependentSchemas: dependentSchemas,
    dependentRequired: dependentRequired,
    storeKeys: storeKeys
  }, props)) : React.createElement(Plugin, _extends({}, props, {
    currentPluginIndex: next
  }));
};