const _excluded = ["Plugin", "currentPluginIndex"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { getNextPlugin } from '@ui-schema/ui-schema/PluginStack';
import { Trans } from '@ui-schema/ui-schema/Translate/Trans';
import { useSchemaNetworkRef } from '@ui-schema/ui-schema/Plugins/ReferencingHandler';
const RefLoader = _ref => {
  let {
      Plugin,
      currentPluginIndex
    } = _ref,
    props = _objectWithoutProperties(_ref, _excluded);
  let {
    schema,
    schemaRef,
    isVirtual
  } = props;
  const {
    loadSchema,
    getSchema
  } = useSchemaNetworkRef();
  const schemaVersion = schema?.get('version');
  const loadedSchema = getSchema(schemaRef, undefined, schemaVersion);
  const loaded = Boolean(loadedSchema);
  if (loaded) {
    schema = loadedSchema;
  }
  React.useEffect(() => {
    if (!loaded) {
      loadSchema(schemaRef, undefined, [schemaVersion]);
    }
  }, [loadSchema, schemaRef, schemaVersion, loaded]);
  return !loaded ? isVirtual ? null : React.createElement(Trans, {
    text: 'labels.loading',
    fallback: 'Loading'
  }) : React.createElement(Plugin, _extends({}, props, {
    currentPluginIndex: currentPluginIndex,
    schema: schema
  }));
};
export const ReferencingNetworkHandler = props => {
  const {
    schema,
    currentPluginIndex
  } = props;
  const next = currentPluginIndex + 1;
  const Plugin = getNextPlugin(next, props.widgets);
  const ref = schema.get('$ref');
  return ref && ref.indexOf('#') !== 0 ? React.createElement(RefLoader, _extends({}, props, {
    Plugin: Plugin,
    currentPluginIndex: next,
    schemaRef: ref
  })) : React.createElement(Plugin, _extends({}, props, {
    currentPluginIndex: next
  }));
};