function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { List, Map } from 'immutable';
import { resolveRef, SchemaRefPending } from '@ui-schema/ui-schema/Plugins/ReferencingHandler';
import { isRootSchema } from '@ui-schema/ui-schema/SchemaRootProvider';
import { getSchemaId } from '@ui-schema/ui-schema/Utils/getSchema';
const handleResolve = (keywords, condition, schema, context, recursive, pending) => {
  Object.keys(keywords).forEach(keyword => {
    const schemaMap = schema.get(keyword);
    if (schemaMap && condition(schemaMap)) {
      schema = schema.set(keyword, schemaMap.map(subSchema => {
        const res = parseRefs(subSchema, context, keywords[keyword] || recursive, pending);
        pending = res.pending;
        return res.schema;
      }));
    }
  });
  return {
    schema,
    pending
  };
};
const checkNestedMapSchema = {
  properties: false
};
const checkNestedArraySchema = {};
const parseRefsInRenderingKeywords = (schema, context, recursive, pending = Map()) => {
  let res = {
    schema,
    pending
  };
  res = handleResolve(checkNestedMapSchema, schemaMap => Map.isMap(schemaMap), res.schema, context, recursive, res.pending);
  res = handleResolve(checkNestedArraySchema, schemaList => List.isList(schemaList), res.schema, context, recursive, res.pending);
  return res;
};
const checkConditionalNestedMapSchema = {
  patternProperties: true,
  dependencies: false,
  dependentSchemas: false
};
const checkConditionalNestedArraySchema = {
  allOf: false,
  oneOf: false,
  anyOf: false,
  items: false
};
const checkSchema = {
  if: true,
  else: false,
  then: false,
  not: false,
  propertyNames: true,
  contains: true
};
const parseRefsInConditionalKeywords = (schema, context, recursive = false, pending = Map()) => {
  let res = {
    schema,
    pending
  };
  Object.keys(checkSchema).forEach(keyword => {
    const schemaCond = res.schema.get(keyword);
    if (schemaCond && Map.isMap(schemaCond)) {
      const resCheckSchema = parseRefs(schemaCond, context, checkSchema[keyword] || recursive, res.pending);
      res.schema = res.schema.set(keyword, resCheckSchema.schema);
      res.pending = resCheckSchema.pending;
    }
  });
  res = handleResolve(checkConditionalNestedMapSchema, schemaMap => Map.isMap(schemaMap), res.schema, context, true, res.pending);
  res = handleResolve(checkConditionalNestedArraySchema, schemaList => List.isList(schemaList), res.schema, context, recursive, res.pending);
  const items = res.schema.get('items');
  if (items && Map.isMap(items)) {
    const itemsSchema = parseRefs(items, context, recursive, res.pending);
    res.schema = res.schema.set('items', itemsSchema.schema);
    res.pending = itemsSchema.pending;
  }
  return res;
};
export const parseRefs = (schema, context, recursive = false, pending = Map()) => {
  const ref = schema.get('$ref');
  const schemaVersion = schema.get('version');
  if (ref) {
    try {
      let resolved = resolveRef(ref, context, schemaVersion);
      schema = resolved ? resolved.mergeDeep(schema.delete('version').delete('$ref')) : schema;
    } catch (e) {
      if (e instanceof SchemaRefPending) {
        const id = context.id || '#';
        pending = pending.updateIn([id, ref], (refPref = List()) => {
          const v = schema.get('version') || '*';
          if (!refPref.contains(v)) {
            refPref = refPref.push(v);
          }
          return refPref;
        });
      } else {
        throw e;
      }
    }
  }
  if (isRootSchema(schema)) {
    context = _objectSpread({}, context);
    context.id = getSchemaId(schema);
    context.root = schema;
    context.defs = schema.get('definitions') || schema.get('$defs');
  }
  let res = {
    schema,
    pending
  };
  res = parseRefsInConditionalKeywords(res.schema, context, recursive, res.pending);
  if (recursive) {
    res = parseRefsInRenderingKeywords(res.schema, context, recursive, res.pending);
  }
  return res;
};