const _excluded = ["rootRenderer"];
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { List } from 'immutable';
import { PluginStack } from '@ui-schema/ui-schema/PluginStack';
import { memo } from '@ui-schema/ui-schema/Utils/memo';
import { useUIMeta } from '@ui-schema/ui-schema/UIMeta';
let DumpRootRenderer = _ref => {
  let {
      rootRenderer: RootRenderer
    } = _ref,
    props = _objectWithoutProperties(_ref, _excluded);
  return props.isVirtual ? React.createElement(PluginStack, props) : React.createElement(RootRenderer, null, React.createElement(PluginStack, props));
};
DumpRootRenderer = memo(DumpRootRenderer);
const mustBeSet = name => {
  if (process.env.NODE_ENV === 'development' || process.env.NODE_ENV === 'test') {
    console.error(name + ' must be set');
  }
  return null;
};
export const UIRootRenderer = ({
  schema,
  rootContext
}) => {
  const {
    widgets
  } = useUIMeta();
  if (!schema) {
    return mustBeSet('schema');
  }
  if (!widgets) {
    return mustBeSet('widgets');
  }
  const {
    RootRenderer
  } = widgets;
  if (!RootRenderer) {
    if (process.env.NODE_ENV === 'development' || process.env.NODE_ENV === 'test') {
      console.error('Widget RootRenderer not existing');
    }
    return null;
  }
  return React.createElement(DumpRootRenderer, {
    rootRenderer: RootRenderer,
    isVirtual: schema?.get('hidden'),
    schema: schema,
    storeKeys: List([]),
    schemaKeys: List([]),
    rootContext: rootContext
  });
};