import React from 'react';
import { isImmutable, Record } from 'immutable';
export function useImmutable(value) {
  const currentState = React.useRef(value);
  if (!isImmutable(currentState.current) && !Record.isRecord(value) || !currentState.current?.equals(value)) {
    currentState.current = value;
  }
  return currentState.current;
}