const _excluded = ["value", "internalValue", "WidgetOverride", "NoWidget", "errors", "onErrors", "requiredList", "currentPluginIndex"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { useImmutable } from '@ui-schema/ui-schema/Utils';
import { widgetMatcher } from '@ui-schema/ui-schema/widgetMatcher';
import { List } from 'immutable';
export const WidgetRenderer = _ref => {
  let {
      value,
      internalValue,
      WidgetOverride,
      NoWidget,
      errors,
      onErrors,
      requiredList,
      currentPluginIndex
    } = _ref,
    props = _objectWithoutProperties(_ref, _excluded);
  const {
    schema,
    widgets,
    isVirtual
  } = props;
  const currentErrors = useImmutable(errors);
  React.useEffect(() => onErrors && onErrors(currentErrors), [onErrors, currentErrors]);
  const schemaType = schema.get('type');
  const widgetName = schema.get('widget');
  const Widget = widgetMatcher({
    isVirtual: Boolean(isVirtual),
    WidgetOverride: WidgetOverride,
    NoWidget: NoWidget,
    widgetName: widgetName,
    schemaType: schemaType,
    widgets: widgets
  });
  const noExtractValue = !isVirtual && (schemaType === 'array' || schemaType === 'object' || List.isList(schemaType) && (schemaType.indexOf('array') !== -1 || schemaType.indexOf('object') !== -1));
  return Widget ? React.createElement(Widget, _extends({}, props, {
    value: noExtractValue ? undefined : value,
    internalValue: noExtractValue ? undefined : internalValue,
    errors: currentErrors
  })) : null;
};