import { prependKey, shouldDeleteOnEmpty } from '@ui-schema/ui-schema/UIStore';
import { List, Map, Record } from 'immutable';
import { updateStoreScope } from '@ui-schema/ui-schema/storeScopeUpdater';
import { storeBuildScopeTree } from '@ui-schema/ui-schema/storeBuildScopeTree';
export const scopeUpdaterValues = (store, storeKeys, newValue, action) => {
  store = storeBuildScopeTree(storeKeys, 'values', store, undefined, true);
  if (shouldDeleteOnEmpty(newValue, action?.schema?.get('deleteOnEmpty') || action?.required, action?.schema?.get('type'))) {
    if (storeKeys.size) {
      const parentStore = store.getIn(prependKey(storeKeys.splice(storeKeys.size - 1, 1), 'values'));
      if (List.isList(parentStore)) {
        store = store.setIn(prependKey(storeKeys, 'values'), null);
      } else if (Map.isMap(parentStore) || Record.isRecord(parentStore)) {
        store = store.deleteIn(prependKey(storeKeys, 'values'));
      }
    } else {
      store = store.deleteIn(['values']);
    }
    return store;
  }
  return updateStoreScope(store, 'values', storeKeys, newValue);
};