"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.storeActionReducers = void 0;
var _immutable = require("immutable");
var _moveItem = require("@ui-schema/ui-schema/Utils/moveItem");
var _excluded = ["value", "internal"],
  _excluded2 = ["value", "internal"],
  _excluded3 = ["value", "internal"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
var storeActionReducers = exports.storeActionReducers = function storeActionReducers(action) {
  switch (action.type) {
    case 'list-item-add':
      return function (_ref) {
        var _ref$value = _ref.value,
          value = _ref$value === void 0 ? (0, _immutable.List)() : _ref$value,
          _ref$internal = _ref.internal,
          internal = _ref$internal === void 0 ? (0, _immutable.Map)() : _ref$internal,
          r = _objectWithoutProperties(_ref, _excluded);
        if ('itemValue' in action) {
          value = value.push(action.itemValue);
        } else {
          var schema = action.schema;
          var items = schema.get('items');
          var type = schema.getIn(['items', 'type']);
          value = value.push(type === 'object' ? (0, _immutable.OrderedMap)() : _immutable.List.isList(items) || type === 'array' ? (0, _immutable.List)() : type === 'string' ? '' : type === 'null' ? null : undefined);
        }
        return _objectSpread({
          value: value,
          internal: internal.update('internals', function () {
            var internalInternals = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : (0, _immutable.List)();
            return internalInternals.push((0, _immutable.Map)());
          })
        }, r);
      };
    case 'list-item-delete':
      return function (_ref2) {
        var _ref2$value = _ref2.value,
          value = _ref2$value === void 0 ? (0, _immutable.List)() : _ref2$value,
          _ref2$internal = _ref2.internal,
          internal = _ref2$internal === void 0 ? (0, _immutable.Map)() : _ref2$internal,
          r = _objectWithoutProperties(_ref2, _excluded2);
        return _objectSpread({
          value: value.splice(action.index, 1),
          internal: internal.update('internals', function () {
            var internalInternals = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : (0, _immutable.List)();
            return internalInternals.splice(action.index, 1);
          })
        }, r);
      };
    case 'list-item-move':
      return function (_ref3) {
        var _ref3$value = _ref3.value,
          value = _ref3$value === void 0 ? (0, _immutable.List)() : _ref3$value,
          _ref3$internal = _ref3.internal,
          internal = _ref3$internal === void 0 ? (0, _immutable.Map)() : _ref3$internal,
          r = _objectWithoutProperties(_ref3, _excluded3);
        return _objectSpread({
          value: (0, _moveItem.moveItem)(value, action.fromIndex, action.toIndex),
          internal: internal.update('internals', function () {
            var internalInternals = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : (0, _immutable.List)();
            return (0, _moveItem.moveItem)(internalInternals.size - 1 < action.toIndex ? internalInternals.set(action.toIndex, undefined) : internalInternals.size - 1 < action.fromIndex ? internalInternals.set(action.fromIndex, undefined) : internalInternals, action.fromIndex, action.toIndex);
          })
        }, r);
      };
    case 'set':
      return action.data;
    case 'update':
      return action.updater;
    default:
      throw new Error('store updater for type not found: ' + action.type);
  }
};